var locations = {};
var links = {};
var prev_location;
var location_dialog;
var link_dialog;
var hosts_html = '';
var services_html = '';
var hostgroups_html = '';
var servicegroups_html = '';
var is_open = false;
$.ajaxSetup({
    'data': {
        'request_context': 'external_widget'
    }
});
// Thanks, ppk
// http://www.quirksmode.org/js/cookies.html
function createCookie(name,value,days) {
    if (days) {
        var date = new Date();
        date.setTime(date.getTime()+(days*24*60*60*1000));
        var expires = "; expires="+date.toGMTString();
    }
    else var expires = "";
    document.cookie = name+"="+value+expires+"; path=/";
}

function readCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for(var i=0;i < ca.length;i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1,c.length);
        if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
    }
    return null;
}

function eraseCookie(name) {
    createCookie(name,"",-1);
}

function array2hash(ary) {
    var hash = {};

    for (var i in ary)
        hash[ary[i].id] = ary[i];

    return hash;
}

function trigger_cb_on_nth_call(cb, n) {
    return function() {
        if (--n <= 0)
            cb();
    };
}

function update(types, callback) {
    if (!types)
        types = ['locations', 'links']
    // trigger link & location updating in parallel
    // this should make reloads look faster
    var cb = trigger_cb_on_nth_call(function() {
        geomap.clear();
        geomap.populate(locations, links);
        if (callback)
            callback();
        if (edit_mode) {
            if (!hosts_html) {
                $.getJSON(base_url + 'index.php/geomap/hosts', function(data) {
                    hosts_html = '';
                    for (var i = 0; i < data.length; i++)
                        hosts_html += '<option value="' + data[i] + '">' + data[i] + '</option>';
                });
            }
            if (!services_html) {
                $.getJSON(base_url + 'index.php/geomap/services', function(data) {
                    services_html = '';
                    for (var i = 0; i < data.length; i++)
                        services_html += '<option value="' + data[i] + '">'
                        + data[i] + '</option>';
                });
            }
            if (!hostgroups_html) {
                $.getJSON(base_url + 'index.php/geomap/hostgroups', function(data) {
                    hostgroups_html = '';
                    for (var i = 0; i < data.length; i++)
                        hostgroups_html += '<option value="' + data[i] + '">' + data[i] + '</option>';
                });
            }
            if (!servicegroups_html) {
                $.getJSON(base_url + 'index.php/geomap/servicegroups', function(data) {
                    servicegroups_html = '';
                    for (var i = 0; i < data.length; i++)
                        servicegroups_html += '<option value="' + data[i] + '">' + data[i] + '</option>';
                });
            }
        }
    }, types.length);
    for (var i in types) {
        (function(){
            var j = i;
            $.getJSON(base_url + 'index.php/geomap/'+types[j], function(data) {
                $('#page_last_updated').html(data.updated);
                window[types[j]] = array2hash(data.items);
                cb();
            });
        })();
    }
}
(function($){
    $.fn.extend({
        highLight: function(options) {

            var defaults = {
                errorColor: '#D96262',
                defaultColor: '#CDCDDC'
            };

            var options = $.extend(defaults, options);

            $(this).bind("alert", function() {
                $(this).css('outline-color', options.errorColor);
                setTimeout( (function(node) { return function() { $(node).css("outline-color", options.defaultColor); $(node).trigger("focus"); } })(this), 1000 );
            });
        }
    });
})(jQuery);

$(document).ready(function() {
    var edit_settings_url = $('#geomap_settings').attr('href');
    var add_edit_location_url, point, label, location_id, type;
    if(_widget_template) {
        setTimeout(function(){ $("#map").attr({ style: null }); }, 300);
    } else {
        $('#refresh').unbind('click').bind('click', function() { update.call(); });
    }

    $(document).on('click', '#geomap_settings', function (e) {
        var href = $(this).attr('href');
        var lightbox = LightboxManager.ajax_form_from_href('Geomap '+$(this).text(), href);
        e.preventDefault();
        return false;
    });

    $(document).on('click', '.add_location', function (e) {
        add_edit_location_url = $(this).attr('href');
        point = $(this).attr('latlng');
        label = "New location";
        location_id = '';
        type = 'add';
        var lightbox = LightboxManager.ajax_form_from_href($(this).text(), add_edit_location_url);
        e.preventDefault();
        return false;
    });

    $(document).on('click', '.edit_location', function (e) {
        add_edit_location_url = $(this).attr('href');
        location_id = $(this).attr('location_id');
        type = 'edit';
        var lightbox = LightboxManager.ajax_form_from_href($(this).text() + ' location', add_edit_location_url);
        e.preventDefault();
        return false;
    });

     $(document).on('click', '.remove_location', function (ev) {
        ev.preventDefault();

        var id = $(this).attr('location_id');
        var location = locations[id];
        LightboxManager.confirm('Remove location "' + location.label + '"?',
            {
                "yes": {
                    "text": "Delete",
                    "cb": function() {
                        for (var i in links) {
                            var link = links[i];
                            if (id == link.id1 || id == link.id2)
                                $.post(
                                    base_url + 'index.php/geomap/remove_link/',
                                    {
                                        'id': link.id,
                                        'csrf_token': _csrf_token
                                    }
                                );
                        }

                        $.post(
                            base_url + 'index.php/geomap/remove_location/',
                            {
                                'id': location.id,
                                'csrf_token': _csrf_token
                            },
                            function() {
                                update();
                            }
                        );
                    }
                },
                "no": "Cancel",
                "focus": "yes"
            }
        );
        $('.lightbox-header h1').text("Delete this location");
        return false;
    });

    function add_edit_locations(location) {
        $('.lightbox-content #location_id').val(location.id);
        $('.lightbox-content #location_point').val(location.point ? location.point : point);
        $('.lightbox-content #location_label').val(location.label ? location.label : label);
        $('.lightbox-content #location_address').val(location.address ? location.address : '');
        $('.lightbox-content #location_description').val(location.description ? location.description : '');
        if (location.object) {
            $('.lightbox-content #location_object_type').val(location.object.type);
            $('.lightbox-content #location_object_type').trigger('change');
            if (location.object.name)
                $('.lightbox-content #location_object_name').val(location.object.name);
            else if (location.object.host && location.object.description)
                $('.lightbox-content #location_object_name').val(location.object.host + ';' + location.object.description);
        } else {
            $('.lightbox-content #location_object_type').val('host');
            $('.lightbox-content #location_object_type').trigger('change');
        }
    }

    $(document).ajaxComplete(function( event, xhr, settings ) {
        if (settings.url === edit_settings_url+"?request_context=external_widget" ||
            settings.url === add_edit_location_url+"&request_context=external_widget") {
            setTimeout(function() {
                $(".lightbox-content").css({"display": "block"});
                $('.lightbox-content #header').remove();
                $('.lightbox-content #map').remove();
                if (settings.url === add_edit_location_url+"&request_context=external_widget") {
                    $('.lightbox-content #hintbar').remove();
                    $('.lightbox-content #location_dialog').show();
                    if(location_id != '') {
                        add_edit_locations(locations[location_id]);
                    }else{
                        add_edit_locations({point: point, label: 'New location'});
                    }
                }
                if (settings.url === edit_settings_url+"?request_context=external_widget") {
                    $('.lightbox-content #geomap-edit-settings').show();
                    $('.lightbox-content #geomap-refresh').slider({
                        value: update_interval,
                        min: 10,
                        max: 500,
                        step: 10,
                        animate: true,
                        slide: function(e, ui) {
                            $('.lightbox-content #geomap-refresh .ui-slider-range').remove();
                            $('.lightbox-content #geo-refresh-rate').val(parseInt(ui.value));
                            $('.lightbox-content #geomap-refresh').append('<div class="ui-slider-range ui-corner-all" style="width:'+parseInt(ui.value - 8)+'px"></div>');
                        }
                    });
                    $('.lightbox-content #geomap-refresh').append('<div class="ui-slider-range ui-corner-all" style="width:'+parseInt(update_interval - 8)+'px"></div>');
                }
            }, 0);
        }
    });

    if ($('#local_maps_url').val() == '')
        $('#local_maps_url').val(window.location.protocol + '//' + window.location.host);
    $('#local_maps_url').highLight();

    $(document).on('change keyup', '#geo-refresh-rate', function (ev) {
        var refresh_rate = $(this).val();
        $('.lightbox-content #geomap-refresh .ui-slider-range').remove();
        $(".lightbox-content #geomap-refresh").slider("value", parseInt(refresh_rate));
        $('.lightbox-content #geomap-refresh').append('<div class="ui-slider-range ui-corner-all" style="width:'+parseInt(refresh_rate - 8)+'px"></div>');
    });

    $(document).on('submit', '#geomap-edit-settings form', function (ev) {
        ev.preventDefault();
        var save_func = function(data) {
            $.ajax({
                type: 'get',
                url: base_url + 'index.php/geomap/savesettings',
                data: data,
                dataType: 'json',
                success: function(res) { window.location.reload(); }
            });
        };
        var data = { 'provider': $('#geo-provider', this).val(),
            'updateInterval': $('#geomap-refresh', this).slider("option", "value") };
        if (data['provider'] === 'google') {
            data['googleMapsApi'] = $('#googleMapsApi', this).val();
        }
        if (data['provider'] === 'osm') {
            data['cloudmadeKey'] = $('#cloudmadeKey', this).val();
        }
        if (data['provider'] === 'local') {
            data['localMapsUrl'] = $('#local_maps_url', this).val();
            if(data['localMapsUrl'][data['localMapsUrl'].length - 1] === "/")
                data['localMapsUrl'] = data['localMapsUrl'].slice(0, -1);
            $("<img style=\"display: none\" src=\"%%URL%%\"></img>".replace("%%URL%%", data['localMapsUrl'] + "/0/0/0.png"))
                .appendTo(document.body)
                .bind(
                "load",
                {d: data},
                function(e) {
                    save_func(e.data.d);
                    $(this).remove();
                }
            )
                .bind(
                "error",
                function() {
                    $('#local_maps_url').triggerHandler("alert");
                    $("#geomap_settings").trigger("click");
                    $(this).remove();
                });
            return;
        }
        save_func(data);
    });

    $(document).on('click', '#geomap-edit-settings form button.cancel', function (ev) {
        LightboxManager.remove_topmost();
        ev.preventDefault();
        return false;
    });

    $(document).on('change', '#geo-provider', function( e ) {
        var settings = $(this).parents('.lightbox-content');
        settings.find('#geo-api')[$(this).val() == 'google' ? 'show' : 'hide']();
        settings.find('#geo-code')[$(this).val() == 'osm' ? 'show' : 'hide']();
        settings.find('#geo-local')[$(this).val() == 'local' ? 'show' : 'hide']();
    });

    // Save map center and zoom on update or change view mode
    var view_position;
    if(view_position = readCookie("geomap_position")) {
        view_position = JSON.parse(view_position);
    }
    $(window).unload(function() {
        createCookie("geomap_position", JSON.stringify(geomap.getViewPoint()), 100);
    });

    $(document).on('click', '#location_dialog input[type=reset]', function (ev) {
        LightboxManager.remove_topmost();
        ev.preventDefault();
        return false;
    });
    link_dialog = $('#link_dialog').dialog({
        autoOpen: false,
        // modal: true, // does not work for map
        resizable: false,
        closeText: '',
        title: 'Edit link'
    });
    $('#link_dialog input[type=reset]').click(function() {
        $(link_dialog).dialog('close');
    });
    var default_view = {
        center: [51.505, -0.09],
        zoom: 5
    };
    var pos = $.extend(default_view, view_position);
    if(geomap.type === "leaflet") {
        pos["cloudmade_key"] = cloudmade_key;
    }
    if(geomap.type === "local") {
        pos["local_maps_url"] = local_maps;
    }
    $('#map').bind('adjust', function() {
        $(this).height($(window).height() - ($(this).offset())['top']);
    });
    $('#map').triggerHandler('adjust');
    $(window).resize(function() {
        $('#map').triggerHandler('adjust');
    });
    geomap.init($.extend({
        base_url: base_url,
        edit_mode: edit_mode,
        iframe_mode: _widget_template
    }, pos));

    $(document).on('change', '.object_type', function( e ) {
        var object_type = $(this);
        var dl = object_type.parent().parent();
        var object_name = dl.find('.object_name');
        var hidden_containers = dl.find('.hidden, .object_name');
        switch (object_type.val()) {
            case 'host':
                object_name.html(hosts_html);
                hidden_containers.show();
                break;

            case 'service':
                object_name.html(services_html)
                hidden_containers.show();
                break;

            case 'hostgroup':
                object_name.html(hostgroups_html)
                hidden_containers.show();
                break;

            case 'servicegroup':
                object_name.html(servicegroups_html)
                hidden_containers.show();
                break;

            default:
                hidden_containers.hide();
        }
    });

    $(document).on('submit', '.lightbox-content #location_form', function () {
        $(this).ajaxSubmit({
            url: base_url + 'index.php/geomap/'+type+'_location/',
            beforeSubmit: function(data, form, options) {
                switch ($('.lightbox-content #location_object_type').val()) {
                    case 'host':
                    case 'hostgroup':
                    case 'servicegroup':
                        data.push({name: 'object_type', value: $('.lightbox-content #location_object_type').val()});
                        data.push({name: 'object_name', value: $('.lightbox-content #location_object_name').val()});
                        break;
                    case 'service':
                        var service = $('.lightbox-content #location_object_name').val().split(';');
                        data.push({name: 'object_type', value: $('.lightbox-content #location_object_type').val()});
                        data.push({name: 'object_host', value: $.trim(service[0])});
                        data.push({name: 'object_description', value: $.trim(service[1])});
                }
                return true;
            },
            success: function() {
                update(['locations'], function() {
                    LightboxManager.remove_topmost();
                    return false;
                });
            }
        });
        return false;
    });
    $('#link_form').ajaxForm({
        url: base_url + 'index.php/geomap/edit_link/',
        beforeSubmit: function(data, form, options) {
            switch ($('#link_object_type').val()) {
                case 'host':
                case 'hostgroup':
                case 'servicegroup':
                    data.push({name: 'object_type', value: $('#link_object_type').val()});
                    data.push({name: 'object_name', value: $('#link_object_name').val()});
                    break;
                case 'service':
                    var service = $('#link_object_name').val().split(';');
                    data.push({name: 'object_type', value: $('#link_object_type').val()});
                    data.push({name: 'object_host', value: $.trim(service[0])});
                    data.push({name: 'object_description', value: $.trim(service[1])});
            }
            return true;
        },
        success: function() {
            update(['links'], function() {
                $(link_dialog).dialog('close');
            });
        }
    });
    geomap.onDetails = function(object) {
        switch (object.type) {
            case 'host':
                return base_url + 'index.php/status/service/?name=' + encodeURIComponent(object.name);
            case 'service':
                return base_url + 'index.php/extinfo/details/?type=service&host=' + encodeURIComponent(object.host) + '&service=' + encodeURIComponent(object.description);
            case 'hostgroup':
                return base_url + 'index.php/status/hostgroup/?group=' + encodeURIComponent(object.name);
            case 'servicegroup':
                return base_url + 'index.php/status/servicegroup/?group=' + encodeURIComponent(object.name) + '&style=detail';
            default:
                return '#';
        }
    };

    geomap.onLink = function(id) {
        var location = locations[id];
        if (prev_location) {
            if (prev_location.id == location.id)
                LightboxManager.alert('You cannot link location to itself');
            else {
                for (var i in links) {
                    var link = links[i];
                    if (link.id1 == prev_location.id && link.id2 == location.id
                        || link.id1 == location.id && link.id2 == prev_location.id) {
                        LightboxManager.alert('Link between "' + prev_location.label + '" and "' + location.label + '" already exists');
                        prev_location = undefined;
                        return;
                    }
                }

                $('#hintbar').hide().html('');
                $.post(
                    base_url + 'index.php/geomap/add_link/',
                    {
                        'id1': prev_location.id,
                        'id2': location.id,
                        'csrf_token': _csrf_token
                    },
                    function() {
                        /* note: delete does not work! */
                        prev_location = undefined;
                        update(['links']);
                    }
                );
            }
        }
        else {
            $('#hintbar').html('Location linking started. Now select another location and click "Link". &nbsp; &nbsp; '
            + '<a href="#" onclick="prev_location = undefined; $(\'#hintbar\').html(\'\'); return false;">Cancel</a>').show();
            prev_location = location;
        }
    };

    geomap.onEditLink = function(id) {
        var link = links[id];
        $(link_dialog).dialog('open');
        $('#link_id').val(link.id);
        $('#link_id1').val(link.id1);
        $('#link_id2').val(link.id2);
        $('#link_description').val(link.description ? link.description : '');
        if (link.object)
            $('#link_object_type').val(link.object.type);
        else
            $('#link_object_type').val('none');
        $('#link_object_type').trigger('change');
    };

    geomap.onRemoveLink = function(id) {
        var link = links[id];
        if (confirm('Remove link "' + link.description + '"?')) {
            $.post(
                base_url + 'index.php/geomap/remove_link/',
                {
                    'id': link.id,
                    'csrf_token': _csrf_token
                },
                function() {
                    update(['links']);
                }
            );
        }
    };
    geomap.onCancel = function(ev) {
        geomap.closeNew();
        LightboxManager.remove_topmost();
        ev.preventDefault();
        return false;
    };
    update();
    if (edit_mode) {
        $('#search_form').bind('submit', function() {
            geomap.search($('#search_text').val(), function(markers) {
                geomap.showSearchMarkers(markers);
            });
            return false;
        });
    }
    else
        setInterval(update, update_interval * 1000);
});
